package de.intevation.flys.client.client.ui.map;

import com.google.gwt.core.client.GWT;

import com.smartgwt.client.widgets.Label;
import com.smartgwt.client.widgets.Window;
import com.smartgwt.client.widgets.layout.HLayout;
import com.smartgwt.client.widgets.layout.VLayout;

import org.gwtopenmaps.openlayers.client.feature.VectorFeature;
import org.gwtopenmaps.openlayers.client.format.GML;
import org.gwtopenmaps.openlayers.client.util.Attributes;
import org.gwtopenmaps.openlayers.client.util.JSObject;

import de.intevation.flys.client.client.FLYSConstants;


public class GetFeatureInfoWindow extends Window {

    protected FLYSConstants MSG = GWT.create(FLYSConstants.class);

    protected VectorFeature[] features;


    public GetFeatureInfoWindow(String gml) {
        super();
        features = new GML().read(gml);
        initLayout();
    }


    protected void initLayout() {
        VLayout root = new VLayout();

        for (VectorFeature feature: features) {
            root.addMember(createFeatureRow(feature));
        }

        addItem(root);

        setWidth(400);
        setHeight(200);
        setTitle(MSG.getFeatureInfoWindowTitle());

        centerInPage();
    }


    protected HLayout createFeatureRow(VectorFeature feature) {
        HLayout r = new HLayout();
        r.setHeight(25);

        String[][] attrs = extractProperties(feature);

        for (String[] attr: attrs) {
            Label l = new Label(attr[0] + ": " + attr[1]);
            l.setHeight(25);
            l.setBorder("1px solid black");
            r.addMember(l);
        }

        return r;
    }


    protected String[][] extractProperties(VectorFeature feature) {
        Attributes tmp   = feature.getAttributes();
        JSObject   jsobj = tmp.getJSObject();

        String   tmpNames = jsobj.getPropertyNames();
        String[] allNames = tmpNames.split(",");

        String[][] attr = new String[allNames.length][];

        for (int i = 0, n = attr.length; i < n; i++) {
            attr[i] = new String[] {
                allNames[i],
                jsobj.getPropertyAsString(allNames[i]) };
        }

        return attr;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
